POJ 3126:Prime Path(素数+BFS)
发布日期:2022-04-01 13:25:21 浏览次数:32 分类:博客文章

本文共 3285 字,大约阅读时间需要 10 分钟。

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.

— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number
1033
1033
for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number
8179
8179
is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an
8
8
, then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from
1033
1033
to
8179
8179
by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened.

— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.

— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.

1033

1733
3733
3739
3779
8779
8179

The cost of this solution is

6
6
pounds. Note that the digit
1
1
which got pasted over in step
2
2
can not be reused in the last step – a new
1
1
must be purchased.

Input

One line with a positive number: the number of test cases (at most

100
100
). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Examples

Input

31033 81791373 80171033 1033

Output

670

题意

给出两个四位的素数

n
,
m
n,m
,要求
n
n
每次只能变换一位,并且变换后的数字依旧是素数。
n
n
经过多少步变换能够变成
m
m
;如果
n
n
无法变成
m
m
,输出Impossible

思路

n
n
的四位数字拆分了,每次变换一位,来判断是否符合条件,如果符合条件,将新数字加入队列,至到数字和
m
m
相等,或队列为空

AC代码

#include 
#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
#include
#define ll long long#define ull unsigned long long#define ms(a,b) memset(a,b,sizeof(a))#define pi acos(-1.0)#define INF 0x7f7f7f7f#define lson o<<1#define rson o<<1|1#define bug cout<<"-------------"<
que; p.num=n; p.step=0; que.push(p); _vis[n]=1; while(!que.empty()) { q=que.front(); que.pop(); if(q.num==m) return q.step; int get[4]; int N=q.num; int _=0; while(N) { get[_++]=N%10; N/=10; } for(int i=0;i<4;i++) { int __=get[i]; for(int j=0;j<=9;j++) { if(get[i]!=j) { get[i]=j; newnum=get[0]+get[1]*10+get[2]*100+get[3]*1000; } if(!vis[newnum]&&newnum>=1000&&newnum<10000&&!_vis[newnum]) { p.num=newnum; p.step=q.step+1; _vis[newnum]=1; que.push(p); } } get[i]=__; } } return -1;}void init(){ vis[0]=vis[1]=1; for(int i=2;i
>t; while(t--) { int n,m; cin>>n>>m; int ans=bfs(n,m); if(ans==-1) cout<<"Impossible"<

转载地址:https://www.cnblogs.com/Friends-A/p/11054980.html 如侵犯您的版权,请留言回复原文章的地址,我们会给您删除此文章,给您带来不便请您谅解!

上一篇:mod4最优路径问题(转载)
下一篇:HDU 1024:Max Sum Plus Plus(DP)

发表评论

最新留言

初次前来,多多关照!
[***.217.46.12]2024年04月07日 00时22分38秒

关于作者

    喝酒易醉,品茶养心,人生如梦,品茶悟道,何以解忧?唯有杜康!
-- 愿君每日到此一游!

推荐文章